; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: TEST_ZUWEISUNG.PAS
 
.nolist
.INCLUDE "m8def.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        RICHTIG  =  0xFF ; BOOLEAN
.equ        ABC  =  0x01 ; BYTE
.equ        DEF  =  0x1F ; BYTE
.equ        GH  =  0xAE ; BYTE
.equ        IJ  =  0x04D2 ; WORD
.equ        KL  =  0xF0F0 ; WORD
.equ        M25  =  0xF07E ; WORD
.equ        N  =  ' ' ; CHAR
 
; *** Variablentabelle ***
 
.dseg
 
X1:   ; Byte
.byte     1
X2:   ; Byte
.byte     1
X3:   ; Byte
.byte     1
X4:   ; Byte
.byte     1
X8:   ; Byte
.byte     1
X56:   ; Byte
.byte     1
Y1:   ; Word
.byte     2
Y2:   ; Word
.byte     2
Y3:   ; Word
.byte     2
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        RJMP       RESET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; ASM
.equ      TCNT1=TCNT1L     
.equ      ADCW=ADCL 
 
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (X2)
        LDS        R16, X2
 
; Zuweisung Ziel /  VAR (X1)
        STS        X1, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (ABC)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (X2)
        STS        X2, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x1F)
        LDI        R16, 0x1F
 
; Zuweisung Ziel /  VAR (X3)
        STS        X3, R16
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y2)
        LDS        R16, Y2
        LDS        R17, Y2+1
 
; Zuweisung Ziel /  VAR (Y1)
        STS        Y1, R16
        STS        Y1+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (KL)
        LDI        R16, LOW(0xF0F0)
        LDI        R17, HIGH(0xF0F0)
 
; Zuweisung Ziel /  VAR (Y2)
        STS        Y2, R16
        STS        Y2+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xA07E)
        LDI        R16, LOW(0xA07E)
        LDI        R17, HIGH(0xA07E)
 
; Zuweisung Ziel /  VAR (Y3)
        STS        Y3, R16
        STS        Y3+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x1F)
        LDI        R16, 0x1F
 
; Zuweisung Ziel /  VAR (DDRB)
        OUT        DDRB, R16
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (X1)
        LDS        R16, X1
 
; Zuweisung Ziel /  VAR (PINC)
        OUT        PINC, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (GH)
        LDI        R16, 0xAE
 
; Zuweisung Ziel /  VAR (PORTD)
        OUT        PORTD, R16
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINC
        IN         R16, PINC
 
; Zuweisung Ziel /  VAR (X1)
        STS        X1, R16
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y2)
        LDS        R16, Y2
        LDS        R17, Y2+1
 
; Zuweisung Ziel /  VAR (ADCW)
        OUT        ADCW, R16
        OUT        ADCW+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x04D2)
        LDI        R16, LOW(0x04D2)
        LDI        R17, HIGH(0x04D2)
 
; Zuweisung Ziel /  VAR (TCNT1)
        OUT        TCNT1, R16
        OUT        TCNT1+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-REG (TCNT1)
        IN         R16, TCNT1
        IN         R17, TCNT1+1
 
; Zuweisung Ziel /  VAR (ADCW)
        OUT        ADCW, R16
        OUT        ADCW+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-REG (TCNT1)
        IN         R16, TCNT1
        IN         R17, TCNT1+1
 
; Zuweisung Ziel /  VAR (Y1)
        STS        Y1, R16
        STS        Y1+1, R17
 
; *** Namen-Liste ***
;
; X1 (V) BYTE
; X2 (V) BYTE
; X3 (V) BYTE
; X4 (V) BYTE
; X8 (V) BYTE
; X56 (V) BYTE
; Y1 (V) WORD
; Y2 (V) WORD
; Y3 (V) WORD
; DDRB (V) BYTECONREG
; PINC (V) BYTECONREG
; PORTD (V) BYTECONREG
; TCNT1 (V) WORDCONREG
; OCR1A (V) WORDCONREG
; OCR1B (V) WORDCONREG
; ADCW (V) WORDCONREG
; ICR1 (V) WORDCONREG
; RICHTIG (C) BOOLEAN Wert=0xFF
; ABC (C) BYTE Wert=0x01
; DEF (C) BYTE Wert=0x1F
; GH (C) BYTE Wert=0xAE
; IJ (C) WORD Wert=0x04D2
; KL (C) WORD Wert=0xF0F0
; M25 (C) WORD Wert=0xF07E
; N (C) CHAR Wert=' '
 
