; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: TEST_CASE.PAS
 
.nolist
.INCLUDE "m644Pdef.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        NORMAL_TM  =  0x00000000 ; DWORD
.equ        IBM_ESC_TM  =  0x00000001 ; DWORD
.equ        IBM_CSI_TM  =  0x00000002 ; DWORD
.equ        IBM_CSI_TM_PAR  =  0x00000003 ; DWORD
.equ        IBM_CSI_TM_PAR_ZEILE  =  0x00000004 ; DWORD
 
; *** Variablentabelle ***
 
.dseg
 
X1:   ; DWord
.byte     4
X2:   ; DWord
.byte     4
TERMINALMODE:   ; DWord
.byte     4
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; PROCEDURE - Anfang (P01)
P01:
 
; CASE OF - lokaler Uebergabeparameter (AAA)
        MOV        R16, R0
        MOV        R17, R1
        MOV        R18, R2
        MOV        R19, R3
 
; CASE OF - vergleiche Listen-Element (NORMAL_TM)
        LDI        R20, 0x00
        LDI        R21, 0x00
        LDI        R22, 0x00
        LDI        R23, 0x00
        CP         R16, R20
        CPC        R17, R21
        CPC        R18, R22
        CPC        R19, R23
        BREQ       M_CASE_03
 
; CASE OF - vergleiche letztes Listen-Element (IBM_ESC_TM)
        LDI        R20, 0x01
        LDI        R21, 0x00
        LDI        R22, 0x00
        LDI        R23, 0x00
        CP         R16, R20
        CPC        R17, R21
        CPC        R18, R22
        CPC        R19, R23
        BREQ       M_CASE_03
        RJMP       M_CASE_02
M_CASE_03:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (00000005)
        LDI        R16, 0x05
        LDI        R17, 0x00
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  VAR (X2)
        STS        X2, R16
        STS        X2+1, R17
        STS        X2+2, R18
        STS        X2+3, R19
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
 
; CASE OF ELSE
M_CASE_02:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (00000008)
        LDI        R16, 0x08
        LDI        R17, 0x00
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  VAR (X2)
        STS        X2, R16
        STS        X2+1, R17
        STS        X2+2, R18
        STS        X2+3, R19
 
; ENDCASE;
M_CASE_01:
 
; PROCEDURE - Ende (P01)
        RET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; CASE OF - DWord-VAR (X1)
        LDS        R16, X1
        LDS        R17, X1+1
        LDS        R18, X1+2
        LDS        R19, X1+3
 
; CASE OF - vergleiche Listen-Element (01)
        LDI        R20, 0x01
        LDI        R21, 0x00
        LDI        R22, 0x00
        LDI        R23, 0x00
        CP         R16, R20
        CPC        R17, R21
        CPC        R18, R22
        CPC        R19, R23
        BREQ       M_CASE_06
 
; CASE OF - vergleiche Listen-Element (02)
        LDI        R20, 0x02
        LDI        R21, 0x00
        LDI        R22, 0x00
        LDI        R23, 0x00
        CP         R16, R20
        CPC        R17, R21
        CPC        R18, R22
        CPC        R19, R23
        BREQ       M_CASE_06
 
; CASE OF - vergleiche Listen-Element (03)
        LDI        R20, 0x03
        LDI        R21, 0x00
        LDI        R22, 0x00
        LDI        R23, 0x00
        CP         R16, R20
        CPC        R17, R21
        CPC        R18, R22
        CPC        R19, R23
        BREQ       M_CASE_06
 
; CASE OF - vergleiche letztes Listen-Element (04)
        LDI        R20, 0x04
        LDI        R21, 0x00
        LDI        R22, 0x00
        LDI        R23, 0x00
        CP         R16, R20
        CPC        R17, R21
        CPC        R18, R22
        CPC        R19, R23
        BREQ       M_CASE_06
        RJMP       M_CASE_05
M_CASE_06:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (00000005)
        LDI        R16, 0x05
        LDI        R17, 0x00
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  VAR (X2)
        STS        X2, R16
        STS        X2+1, R17
        STS        X2+2, R18
        STS        X2+3, R19
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_04
M_CASE_05:
 
; CASE OF - vergleiche DWord-Element-Bereich <von> (05)
        LDI        R20, 0x05
        LDI        R21, 0x00
        LDI        R22, 0x00
        LDI        R23, 0x00
        CP         R16, R20
        CPC        R17, R21
        CPC        R18, R22
        CPC        R19, R23
        BRCC       M_CASE_09
        RJMP       M_CASE_07
M_CASE_09:
 
; CASE OF - vergleiche DWord-Element-Bereich <bis> (12)
        LDI        R20, 0x0C
        LDI        R21, 0x00
        LDI        R22, 0x00
        LDI        R23, 0x00
        CP         R20, R16
        CPC        R21, R17
        CPC        R22, R18
        CPC        R23, R19
        BRCC       M_CASE_08
        RJMP       M_CASE_07
M_CASE_08:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (00000019)
        LDI        R16, 0x19
        LDI        R17, 0x00
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  VAR (X2)
        STS        X2, R16
        STS        X2+1, R17
        STS        X2+2, R18
        STS        X2+3, R19
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_04
M_CASE_07:
 
; CASE OF - vergleiche Einzel-Element (14)
        LDI        R20, 0x0E
        LDI        R21, 0x00
        LDI        R22, 0x00
        LDI        R23, 0x00
        CP         R16, R20
        CPC        R17, R21
        CPC        R18, R22
        CPC        R19, R23
        BREQ       M_CASE_011
        RJMP       M_CASE_010
M_CASE_011:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0000002D)
        LDI        R16, 0x2D
        LDI        R17, 0x00
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  VAR (X2)
        STS        X2, R16
        STS        X2+1, R17
        STS        X2+2, R18
        STS        X2+3, R19
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_04
 
; CASE OF ELSE
M_CASE_010:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (00000008)
        LDI        R16, 0x08
        LDI        R17, 0x00
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  VAR (X2)
        STS        X2, R16
        STS        X2+1, R17
        STS        X2+2, R18
        STS        X2+3, R19
 
; ENDCASE;
M_CASE_04:
 
; *** Namen-Liste ***
;
; NORMAL_TM (C) DWORD Wert=00000000
; IBM_ESC_TM (C) DWORD Wert=00000001
; IBM_CSI_TM (C) DWORD Wert=00000002
; IBM_CSI_TM_PAR (C) DWORD Wert=00000003
; IBM_CSI_TM_PAR_ZEILE (C) DWORD Wert=00000004
; X1 (V) DWORD
; X2 (V) DWORD
; TERMINALMODE (V) DWORD
; P01 (P) 
 
; *** Prozedur/Function-Liste ***
;
; PROCEDURE P01 (AAA : DWORD);
 
