; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: TEST_ARRAY.PAS
 
.nolist
.INCLUDE "m8def.inc"
.list
 
; *** Variablentabelle ***
 
.dseg
 
A1:   ; Byte
.byte     1
X1:   ; Word
.byte     2
 
A2:
.byte     301
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        RJMP       RESET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0018)
        LDI        R16, LOW(0x0018)
        LDI        R17, HIGH(0x0018)
 
; Zuweisung Ziel /  VAR (X1)
        STS        X1, R16
        STS        X1+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x42)
        LDI        R16, 0x42
 
; Zuweisung Ziel /  VAR (A1)
        STS        A1, R16
 
; VAR ARRAY POSITION - Ausdruck erster Faktor / Zahlenwert (0x007B)
        LDI        R16, LOW(0x007B)
        LDI        R17, HIGH(0x007B)
 
; VAR ARRAY POSITION - Ausdruck zweiter Faktor / Word-VAR (X1)
        LDS        R18, X1
        LDS        R19, X1+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; VAR ARRAY Ziel Zeiger berechnen (A2)
        LDI        ZL, LOW(A2)
        LDI        ZH, HIGH(A2)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (A1)
        LDS        R16, A1
 
; Zuweisung Ziel /  VAR ARRAY (A2)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; *** Namen-Liste ***
;
; A1 (V) BYTE
; X1 (V) WORD
; A2 (Y) BYTE
 
