; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: DWORD.PAS
 
.nolist
.INCLUDE "m1284Pdef.inc"
.list
 
; *** Variablentabelle ***
 
.dseg
 
ZEICHENBREITE:   ; Word
.byte     2
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; PROCEDURE - Anfang (P2)
P2:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (00000400)
        LDI        R16, 0x00
        LDI        R17, 0x04
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
        MOV        R2, R18
        MOV        R3, R19
 
; Zuweisung Quelle - Ausdruck / WordToDW(ZEICHENBREITE)
        LDS        R16, ZEICHENBREITE
        LDS        R17, ZEICHENBREITE+1
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZB)
        MOV        R4, R16
        MOV        R5, R17
        MOV        R6, R18
        MOV        R7, R19
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
        MOV        R18, R2
        MOV        R19, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (00000400)
        LDI        R20, 0x00
        LDI        R21, 0x04
        LDI        R22, 0x00
        LDI        R23, 0x00
 
; Operator +
        ADD        R16, R20
        ADC        R17, R21
        ADC        R18, R22
        ADC        R19, R23
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
        MOV        R2, R18
        MOV        R3, R19
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
        MOV        R18, R2
        MOV        R19, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (ZB)
        MOV        R20, R4
        MOV        R21, R5
        MOV        R22, R6
        MOV        R23, R7
 
; Operator -
        SUB        R16, R20
        SBC        R17, R21
        SBC        R18, R22
        SBC        R19, R23
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
        MOV        R2, R18
        MOV        R3, R19
 
; PROCEDURE - Ende (P2)
        RET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0008)
        LDI        R16, LOW(0x0008)
        LDI        R17, HIGH(0x0008)
 
; Zuweisung Ziel /  VAR (ZEICHENBREITE)
        STS        ZEICHENBREITE, R16
        STS        ZEICHENBREITE+1, R17
 
; Aufruf PROCEDURE (P2)
        CALL       P2
 
; *** Namen-Liste ***
;
; ZEICHENBREITE (V) WORD
; P2 (P) 
 
; *** Prozedur/Function-Liste ***
;
; PROCEDURE P2 (ADRESSE : DWORD) (ZB : DWORD);
 
