; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: TEST_ISR.PAS
 
.nolist
.INCLUDE "m8def.inc"
.list
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        RJMP       RESET
 
; PROCEDURE - Anfang (INITPORTS)
INITPORTS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRB)
        OUT        DDRB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFC)
        LDI        R16, 0xFC
 
; Zuweisung Ziel /  VAR (DDRD)
        OUT        DDRD, R16
 
; PROCEDURE - Ende (INITPORTS)
        RET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; Aufruf PROCEDURE (INITPORTS)
        RCALL      INITPORTS
 
; Interrupt erlauben
        SEI
 
; LOOP - Start_Marke
M_LOOP_01:
 
; LOOP - Ende
        RJMP       M_LOOP_01
 
; Interrupt verbieten
        CLI
 
; *** Namen-Liste ***
;
; SREG (V) BYTECONREG
; SPH (V) BYTECONREG
; SPL (V) BYTECONREG
; GICR (V) BYTECONREG
; GIFR (V) BYTECONREG
; TIMSK (V) BYTECONREG
; TIFR (V) BYTECONREG
; SPMCR (V) BYTECONREG
; TWCR (V) BYTECONREG
; MCUCR (V) BYTECONREG
; MCUCSR (V) BYTECONREG
; MCUSR (V) BYTECONREG
; TCCR0 (V) BYTECONREG
; TCNT0 (V) BYTECONREG
; OSCCAL (V) BYTECONREG
; SFIOR (V) BYTECONREG
; TCCR1A (V) BYTECONREG
; TCCR1B (V) BYTECONREG
; TCNT1H (V) BYTECONREG
; TCNT1L (V) BYTECONREG
; OCR1AH (V) BYTECONREG
; OCR1AL (V) BYTECONREG
; OCR1BH (V) BYTECONREG
; OCR1BL (V) BYTECONREG
; ICR1H (V) BYTECONREG
; ICR1L (V) BYTECONREG
; TCCR2 (V) BYTECONREG
; TCNT2 (V) BYTECONREG
; OCR2 (V) BYTECONREG
; ASSR (V) BYTECONREG
; WDTCR (V) BYTECONREG
; UBRRH (V) BYTECONREG
; UBRRL (V) BYTECONREG
; UCSRC (V) BYTECONREG
; EEARH (V) BYTECONREG
; EEARL (V) BYTECONREG
; EEDR (V) BYTECONREG
; EECR (V) BYTECONREG
; SPDR (V) BYTECONREG
; SPSR (V) BYTECONREG
; SPCR (V) BYTECONREG
; UCSRA (V) BYTECONREG
; UCSRB (V) BYTECONREG
; ACSR (V) BYTECONREG
; ADMUX (V) BYTECONREG
; ADCSR (V) BYTECONREG
; ADCSRA (V) BYTECONREG
; ADCH (V) BYTECONREG
; ADCL (V) BYTECONREG
; TWDR (V) BYTECONREG
; TWAR (V) BYTECONREG
; TWSR (V) BYTECONREG
; TWBR (V) BYTECONREG
; PORTB (V) BYTECONREG
; DDRB (V) BYTECONREG
; PINB (V) BYTECONREG
; PORTC (V) BYTECONREG
; DDRC (V) BYTECONREG
; PINC (V) BYTECONREG
; PORTD (V) BYTECONREG
; DDRD (V) BYTECONREG
; PIND (V) BYTECONREG
; EEAR (V) WORDCONREG
; TCNT1 (V) WORDCONREG
; OCR1A (V) WORDCONREG
; OCR1B (V) WORDCONREG
; ICR1 (V) WORDCONREG
; ADCHL (V) WORDCONREG
; RXC (B) BIT
; TXC (B) BIT
; UDRE (B) BIT
; INITPORTS (P) 
 
; *** Prozedur/Function-Liste ***
;
; PROCEDURE INITPORTS;
 
