; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: TEST_CONST.PAS
 
.nolist
.INCLUDE "m8def.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        C_CURR_1  =  0xFFFFFFFFFFFFBD98 ; CURRENCY
.equ        C_CURR_2  =  0x0000000000002134 ; CURRENCY
.equ        C_CURR_3  =  0xFFFFFFFFFFFFC78E ; CURRENCY
.equ        C_CURR_4  =  0xFFFFFFFFFFFF63C0 ; CURRENCY
 
; *** Variablentabelle ***
 
.dseg
 
V_CURR_1:   ; Currency
.byte     8
V_CURR_2:   ; Currency
.byte     8
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        RJMP       RESET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (C_CURR_1)
        LDI        R16, 0x98
        LDI        R17, 0xBD
        LDI        R18, 0xFF
        LDI        R19, 0xFF
        LDI        R20, 0xFF
        LDI        R21, 0xFF
        LDI        R22, 0xFF
        LDI        R23, 0xFF
 
; Zuweisung Ziel /  VAR (V_CURR_1)
        STS        V_CURR_1, R16
        STS        V_CURR_1+1, R17
        STS        V_CURR_1+2, R18
        STS        V_CURR_1+3, R19
        STS        V_CURR_1+4, R20
        STS        V_CURR_1+5, R21
        STS        V_CURR_1+6, R22
        STS        V_CURR_1+7, R23
 
; Zuweisung Quelle - Ausdruck / Currency-VAR (V_CURR_1)
        LDS        R16, V_CURR_1
        LDS        R17, V_CURR_1+1
        LDS        R18, V_CURR_1+2
        LDS        R19, V_CURR_1+3
        LDS        R20, V_CURR_1+4
        LDS        R21, V_CURR_1+5
        LDS        R22, V_CURR_1+6
        LDS        R23, V_CURR_1+7
 
; Zuweisung Ziel /  VAR (V_CURR_2)
        STS        V_CURR_2, R16
        STS        V_CURR_2+1, R17
        STS        V_CURR_2+2, R18
        STS        V_CURR_2+3, R19
        STS        V_CURR_2+4, R20
        STS        V_CURR_2+5, R21
        STS        V_CURR_2+6, R22
        STS        V_CURR_2+7, R23
 
; *** Namen-Liste ***
;
; C_CURR_1 (C) CURRENCY Wert=-17000
; C_CURR_2 (C) CURRENCY Wert=8500
; C_CURR_3 (C) CURRENCY Wert=-14450
; C_CURR_4 (C) CURRENCY Wert=-40000
; V_CURR_1 (V) CURRENCY
; V_CURR_2 (V) CURRENCY
 
