; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: TEST_IF_THEN.PAS
 
.nolist
.INCLUDE "m8def.inc"
.list
 
; *** Variablentabelle ***
 
.dseg
 
DBG_ANFANG_VAR_TABELLE:
 
ZAHL1:   ; Byte
.byte     1
ZAHL2:   ; Byte
.byte     1
ZAHL3:   ; Byte
.byte     1
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        RJMP       RESET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x05)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (ZAHL1)
        STS        ZAHL1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x06)
        LDI        R16, 0x06
 
; Zuweisung Ziel /  VAR (ZAHL2)
        STS        ZAHL2, R16
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (ZAHL1)
        LDS        R16, ZAHL1
 
; IF THEN - Ausdruck zweiter Faktor / Byte-VAR (ZAHL2)
        LDS        R18, ZAHL2
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_04
        CLR        R16
        RJMP       M_VERGL_05
M_VERGL_04:
        SER        R16
M_VERGL_05:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_01
        RJMP       M_IF_02
M_IF_01:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (ZAHL3)
        STS        ZAHL3, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_03
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_02:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (ZAHL3)
        STS        ZAHL3, R16
 
; IF_THEN_ELSE - Ende
M_IF_03:
 
; *** Namen-Liste ***
;
; ZAHL1 (V) BYTE
; ZAHL2 (V) BYTE
; ZAHL3 (V) BYTE
 
