; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: TEST_ARRAY.PAS
 
.nolist
.INCLUDE "m644Pdef.inc"
.list
 
; *** Variablentabelle ***
 
.dseg
 
X_MAX:   ; Byte
.byte     1
X_KREIS:   ; Byte
.byte     1
W2:   ; Word
.byte     2
GRAD:   ; Word
.byte     2
DW1:   ; DWord
.byte     4
DW2:   ; DWord
.byte     4
DW3:   ; DWord
.byte     4
SIN_DW1:   ; DWord
.byte     4
SIN_DW2:   ; DWord
.byte     4
X_PIX_POS:   ; Word
.byte     2
Y_PIX_POS:   ; Word
.byte     2
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; FUNCTION - Anfang (SINUS)
SINUS:
 
; ARRAY - Ausdruck / lokaler Uebergabeparameter (WINKEL)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (SINTAB)
        LDI        ZL, LOW(2*SINTAB)
        LDI        ZH, HIGH(2*SINTAB)
        LSL        R16
        ROL        R17
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z+
        LPM        R17, Z+
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck / WordToDW(W1)
        MOV        R16, R6
        MOV        R17, R7
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  VAR (SIN_DW1)
        STS        SIN_DW1, R16
        STS        SIN_DW1+1, R17
        STS        SIN_DW1+2, R18
        STS        SIN_DW1+3, R19
 
; Zuweisung Quelle - Ausdruck / WordToDW(RADIUS)
        MOV        R16, R2
        MOV        R17, R3
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  VAR (SIN_DW2)
        STS        SIN_DW2, R16
        STS        SIN_DW2+1, R17
        STS        SIN_DW2+2, R18
        STS        SIN_DW2+3, R19
 
; Zuweisung Quelle - Ausdruck erster Faktor / DWord-VAR (SIN_DW1)
        LDS        R16, SIN_DW1
        LDS        R17, SIN_DW1+1
        LDS        R18, SIN_DW1+2
        LDS        R19, SIN_DW1+3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / DWord-VAR (SIN_DW2)
        LDS        R20, SIN_DW2
        LDS        R21, SIN_DW2+1
        LDS        R22, SIN_DW2+2
        LDS        R23, SIN_DW2+3
 
; Operator *
        CALL       ASM_UP_MUL32
 
; Zuweisung Ziel /  VAR (SIN_DW1)
        STS        SIN_DW1, R16
        STS        SIN_DW1+1, R17
        STS        SIN_DW1+2, R18
        STS        SIN_DW1+3, R19
 
; Zuweisung Quelle - Ausdruck erster Faktor / DWord-VAR (SIN_DW1)
        LDS        R16, SIN_DW1
        LDS        R17, SIN_DW1+1
        LDS        R18, SIN_DW1+2
        LDS        R19, SIN_DW1+3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0000FFFF)
        LDI        R20, 0xFF
        LDI        R21, 0xFF
        LDI        R22, 0x00
        LDI        R23, 0x00
 
; Operator DIV
        CALL       ASM_UP_MDIV32
 
; Zuweisung Ziel /  VAR (SIN_DW1)
        STS        SIN_DW1, R16
        STS        SIN_DW1+1, R17
        STS        SIN_DW1+2, R18
        STS        SIN_DW1+3, R19
 
; Zuweisung Quelle - Ausdruck / DWLow(SIN_DW1)
        LDS        R16, SIN_DW1
        LDS        R17, SIN_DW1+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R6, R16
        MOV        R7, R17
 
; RESULT Word-Variable - FUNCTION (SINUS)
        MOV        R4, R6
        MOV        R5, R7
 
; Ende Word - FUNCTION (SINUS)
        MOV        R16, R4
        MOV        R17, R5
 
; FUNCTION - Ende (SINUS)
        RET
 
; PROCEDURE - Anfang (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
GRAFIKZEICHNEKREIS_ON_RAMPAGE:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WINKEL)
        MOV        R6, R16
        MOV        R7, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0059)
        LDI        R16, LOW(0x0059)
        LDI        R17, HIGH(0x0059)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R6
        MOV        R19, R7
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_01:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_02
        RJMP       M_FTD_03
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_02:
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (RADIUS) retten
        MOV        R16, R0
        MOV        R17, R1
 
; Parameter (WINKEL) retten
        MOV        R22, R6
        MOV        R23, R7
 
; lokalen Parameter (RADIUS) an Funktion (SINUS)
        MOV        R2, R16
        MOV        R3, R17
 
; lokalen Parameter (WINKEL) an Funktion (SINUS)
        MOV        R0, R22
        MOV        R1, R23
 
; Aufruf Funktion (SINUS)
        CALL       SINUS
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Zahlenwert (0x005A)
        LDI        R16, LOW(0x005A)
        LDI        R17, HIGH(0x005A)
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (WINKEL)
        MOV        R18, R6
        MOV        R19, R7
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R4, R16
        MOV        R5, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (RADIUS) retten
        MOV        R16, R0
        MOV        R17, R1
 
; Parameter (Y1) retten
        MOV        R20, R4
        MOV        R21, R5
 
; lokalen Parameter (RADIUS) an Funktion (SINUS)
        MOV        R2, R16
        MOV        R3, R17
 
; lokalen Parameter (Y1) an Funktion (SINUS)
        MOV        R0, R20
        MOV        R1, R21
 
; Aufruf Funktion (SINUS)
        CALL       SINUS
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (X1)
        MOV        R18, R2
        MOV        R19, R3
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (Y1)
        MOV        R18, R4
        MOV        R19, R5
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R6
        MOV        R19, R7
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R6, R18
        MOV        R7, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_01
 
; FOR TO DO - Ende
M_FTD_03:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WINKEL)
        MOV        R6, R16
        MOV        R7, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0059)
        LDI        R16, LOW(0x0059)
        LDI        R17, HIGH(0x0059)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R6
        MOV        R19, R7
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_04:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_05
        RJMP       M_FTD_06
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_05:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Zahlenwert (0x005A)
        LDI        R16, LOW(0x005A)
        LDI        R17, HIGH(0x005A)
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (WINKEL)
        MOV        R18, R6
        MOV        R19, R7
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
        MOV        R3, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (RADIUS) retten
        MOV        R16, R0
        MOV        R17, R1
 
; Parameter (X1) retten
        MOV        R18, R2
        MOV        R19, R3
 
; lokalen Parameter (RADIUS) an Funktion (SINUS)
        MOV        R2, R16
        MOV        R3, R17
 
; lokalen Parameter (X1) an Funktion (SINUS)
        MOV        R0, R18
        MOV        R1, R19
 
; Aufruf Funktion (SINUS)
        CALL       SINUS
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
        MOV        R3, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (RADIUS) retten
        MOV        R16, R0
        MOV        R17, R1
 
; Parameter (WINKEL) retten
        MOV        R22, R6
        MOV        R23, R7
 
; lokalen Parameter (RADIUS) an Funktion (SINUS)
        MOV        R2, R16
        MOV        R3, R17
 
; lokalen Parameter (WINKEL) an Funktion (SINUS)
        MOV        R0, R22
        MOV        R1, R23
 
; Aufruf Funktion (SINUS)
        CALL       SINUS
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (X1)
        MOV        R18, R2
        MOV        R19, R3
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (Y1)
        MOV        R18, R4
        MOV        R19, R5
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R6
        MOV        R19, R7
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R6, R18
        MOV        R7, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_04
 
; FOR TO DO - Ende
M_FTD_06:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WINKEL)
        MOV        R6, R16
        MOV        R7, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0059)
        LDI        R16, LOW(0x0059)
        LDI        R17, HIGH(0x0059)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R6
        MOV        R19, R7
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_07:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_08
        RJMP       M_FTD_09
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_08:
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (RADIUS) retten
        MOV        R16, R0
        MOV        R17, R1
 
; Parameter (WINKEL) retten
        MOV        R22, R6
        MOV        R23, R7
 
; lokalen Parameter (RADIUS) an Funktion (SINUS)
        MOV        R2, R16
        MOV        R3, R17
 
; lokalen Parameter (WINKEL) an Funktion (SINUS)
        MOV        R0, R22
        MOV        R1, R23
 
; Aufruf Funktion (SINUS)
        CALL       SINUS
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Zahlenwert (0x005A)
        LDI        R16, LOW(0x005A)
        LDI        R17, HIGH(0x005A)
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (WINKEL)
        MOV        R18, R6
        MOV        R19, R7
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R4, R16
        MOV        R5, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (RADIUS) retten
        MOV        R16, R0
        MOV        R17, R1
 
; Parameter (Y1) retten
        MOV        R20, R4
        MOV        R21, R5
 
; lokalen Parameter (RADIUS) an Funktion (SINUS)
        MOV        R2, R16
        MOV        R3, R17
 
; lokalen Parameter (Y1) an Funktion (SINUS)
        MOV        R0, R20
        MOV        R1, R21
 
; Aufruf Funktion (SINUS)
        CALL       SINUS
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (X1)
        MOV        R18, R2
        MOV        R19, R3
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (Y1)
        MOV        R18, R4
        MOV        R19, R5
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R6
        MOV        R19, R7
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R6, R18
        MOV        R7, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_07
 
; FOR TO DO - Ende
M_FTD_09:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WINKEL)
        MOV        R6, R16
        MOV        R7, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0059)
        LDI        R16, LOW(0x0059)
        LDI        R17, HIGH(0x0059)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R6
        MOV        R19, R7
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_010:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_011
        RJMP       M_FTD_012
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_011:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Zahlenwert (0x005A)
        LDI        R16, LOW(0x005A)
        LDI        R17, HIGH(0x005A)
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (WINKEL)
        MOV        R18, R6
        MOV        R19, R7
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
        MOV        R3, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (RADIUS) retten
        MOV        R16, R0
        MOV        R17, R1
 
; Parameter (X1) retten
        MOV        R18, R2
        MOV        R19, R3
 
; lokalen Parameter (RADIUS) an Funktion (SINUS)
        MOV        R2, R16
        MOV        R3, R17
 
; lokalen Parameter (X1) an Funktion (SINUS)
        MOV        R0, R18
        MOV        R1, R19
 
; Aufruf Funktion (SINUS)
        CALL       SINUS
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
        MOV        R3, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (RADIUS) retten
        MOV        R16, R0
        MOV        R17, R1
 
; Parameter (WINKEL) retten
        MOV        R22, R6
        MOV        R23, R7
 
; lokalen Parameter (RADIUS) an Funktion (SINUS)
        MOV        R2, R16
        MOV        R3, R17
 
; lokalen Parameter (WINKEL) an Funktion (SINUS)
        MOV        R0, R22
        MOV        R1, R23
 
; Aufruf Funktion (SINUS)
        CALL       SINUS
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (X1)
        MOV        R18, R2
        MOV        R19, R3
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (Y1)
        MOV        R18, R4
        MOV        R19, R5
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R6
        MOV        R19, R7
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R6, R18
        MOV        R7, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_010
 
; FOR TO DO - Ende
M_FTD_012:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        RET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; Word-Parameter(1) fuer FUNCTION (SINUS)
        LDI        R16, LOW(0x002D)
        MOV        R0, R16
        LDI        R17, HIGH(0x002D)
        MOV        R1, R17
 
; Word-Parameter(2) fuer FUNCTION (SINUS)
        LDI        R16, LOW(0x005A)
        MOV        R2, R16
        LDI        R17, HIGH(0x005A)
        MOV        R3, R17
 
; Aufruf Funktion (SINUS)
        CALL       SINUS
 
; Zuweisung Ziel /  VAR (W2)
        STS        W2, R16
        STS        W2+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x64)
        LDI        R16, 0x64
 
; Zuweisung Ziel /  VAR (X_MAX)
        STS        X_MAX, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x002D)
        LDI        R16, LOW(0x002D)
        LDI        R17, HIGH(0x002D)
 
; Zuweisung Ziel /  VAR (GRAD)
        STS        GRAD, R16
        STS        GRAD+1, R17
 
; ARRAY - Ausdruck / Word-VAR (GRAD)
        LDS        R16, GRAD
        LDS        R17, GRAD+1
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (SINTAB)
        LDI        ZL, LOW(2*SINTAB)
        LDI        ZH, HIGH(2*SINTAB)
        LSL        R16
        ROL        R17
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z+
        LPM        R17, Z+
 
; Zuweisung Ziel /  VAR (W2)
        STS        W2, R16
        STS        W2+1, R17
 
; Zuweisung Quelle - Ausdruck / WordToDW(W2)
        LDS        R16, W2
        LDS        R17, W2+1
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  VAR (DW1)
        STS        DW1, R16
        STS        DW1+1, R17
        STS        DW1+2, R18
        STS        DW1+3, R19
 
; Zuweisung Quelle - Ausdruck / ByteToDW(X_MAX)
        LDS        R16, X_MAX
        LDI        R17, 0x00
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  VAR (DW2)
        STS        DW2, R16
        STS        DW2+1, R17
        STS        DW2+2, R18
        STS        DW2+3, R19
 
; Zuweisung Quelle - Ausdruck erster Faktor / DWord-VAR (DW1)
        LDS        R16, DW1
        LDS        R17, DW1+1
        LDS        R18, DW1+2
        LDS        R19, DW1+3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / DWord-VAR (DW2)
        LDS        R20, DW2
        LDS        R21, DW2+1
        LDS        R22, DW2+2
        LDS        R23, DW2+3
 
; Operator *
        CALL       ASM_UP_MUL32
 
; Zuweisung Ziel /  VAR (DW3)
        STS        DW3, R16
        STS        DW3+1, R17
        STS        DW3+2, R18
        STS        DW3+3, R19
 
; Zuweisung Quelle - Ausdruck erster Faktor / DWord-VAR (DW3)
        LDS        R16, DW3
        LDS        R17, DW3+1
        LDS        R18, DW3+2
        LDS        R19, DW3+3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0000FFFF)
        LDI        R20, 0xFF
        LDI        R21, 0xFF
        LDI        R22, 0x00
        LDI        R23, 0x00
 
; Operator DIV
        CALL       ASM_UP_MDIV32
 
; Zuweisung Ziel /  VAR (DW3)
        STS        DW3, R16
        STS        DW3+1, R17
        STS        DW3+2, R18
        STS        DW3+3, R19
 
; Zuweisung Quelle - Ausdruck / DWByte(0,DW3)
        LDS        R16, DW3
 
; Zuweisung Ziel /  VAR (X_KREIS)
        STS        X_KREIS, R16
 
; *** Unterprogramm Bibliothek ***
; Division von 2 32-Bit Zahlen (DWORD)
; Version 1.0, Stand 28.05.2013
;
; Uebergabe: R16 Divident D0
;            R17 Divident D1
;            R18 Divident D2
;            R19 Divident D3
;            R20 Divisor D0
;            R21 Divisor D1
;            R22 Divisor D2
;            R23 Divisor D3
;
;  Ergebnis: R16 Quotient D0
;            R17 Quotient D1
;            R18 Quotient D2
;            R19 Quotient D3
;            R20 Rest D0
;            R21 Rest D1
;            R22 Rest D2
;            R23 Rest D3
;
; Temporaere Register: R24,R25,R26,R27,R28


ASM_UP_MDIV32:

        LDI        R24, 32   ; 32 Schritte 

        MOV        R25, R20  ; R25 = Divisor D0
        MOV        R26, R21  ; R26 = Divisor D1
        MOV        R27, R22  ; R27 = Divisor D2
        MOV        R28, R23  ; R28 = Divisor D3

        CLR        R20       ; R20 = Rest D0 loeschen
        CLR        R21       ; R21 = Rest D1 loeschen
        CLR        R22       ; R22 = Rest D2 loeschen
        CLR        R23       ; R23 = Rest D3 loeschen

ASM_UP_MDIV32a:
			      
        LSL        R16       ; Divident D0 links Quotient links Bit_0 <- 0   
        ROL        R17       ; Divident D1
        ROL        R18       ; Divident D2
        ROL        R19       ; Divident D3
        ROL        R20       ; Rest D0
        ROL        R21       ; Rest D1
        ROL        R22       ; Rest D2
        ROL        R23       ; Rest D3

        CP         R20, R25  ; Test Rest D0 - Divisor D0
        CPC        R21, R26  ; Test Rest D1 - Divisor D1
        CPC        R22, R27  ; Test Rest D2 - Divisor D2
        CPC        R23, R28  ; Test Rest D3 - Divisor D3

        BRLO       ASM_UP_MDIV32b   ; Rest < Divisor : Quotient Bit_0 bleibt 0

        SUB        R20, R25  ; Rest D0 >= Divisor D0 abziehen
        SBC        R21, R26  ; Rest D1 >= Divisor D1 abziehen
        SBC        R22, R27  ; Rest D2 >= Divisor D2 abziehen
        SBC        R23, R28  ; Rest D3 >= Divisor D3 abziehen

        INC        R16       ; Quotient Bit_0 wird 1
ASM_UP_MDIV32b:

        DEC        R24       ; Zaehler - 1
        BRNE       ASM_UP_MDIV32a   ; wiederhole 32 mal



        RET






; Multiplikation von 2 32-Bit Zahlen (DWORD)
; Quelle: Mikrocomputertechnik mit Controllern der Atmel AVR-RISC-Familie
;         Guenter Schmitt, ISBN 978-3-486-58988-7
; Version 1.0, Stand 11.01.2013
;
; Uebergabe: R16:R17:18:19 erster Faktor
;            R20:R21:22:23 zweiter Faktor
; Temporaere Register: R24,R25,R26,R27,R28
;                      R20,R21,R22,R23,R24
ASM_UP_MUL32:

        PUSH       R0
        PUSH       R1

        CLR        R28
        MUL        R21, R17
        MOVW       R27:R26, R1:R0
        MUL        R20, R16
        MOVW       R25:R24, R1:R0
        MUL        R21, R16
        ADD        R25, R0
        ADC        R26, R1
        ADC        R27, R28
        MUL        R17, R20
        ADD        R25, R0
        ADC        R26, R1
        ADC        R27, R28
        MOVW       R17:R16, R25:R24       ; Produkt Low
        MOVW       R19:R18, R27:R26       ; Produkt High

        POP        R1
        POP        R0		

        RET






 
; *** Namen-Liste ***
;
; SINTAB (A) 
; X_MAX (V) BYTE
; X_KREIS (V) BYTE
; W2 (V) WORD
; GRAD (V) WORD
; DW1 (V) DWORD
; DW2 (V) DWORD
; DW3 (V) DWORD
; SIN_DW1 (V) DWORD
; SIN_DW2 (V) DWORD
; X_PIX_POS (V) WORD
; Y_PIX_POS (V) WORD
; SINUS (F) 
; GRAFIKZEICHNEKREIS_ON_RAMPAGE (P) 
 
; *** Prozedur/Function-Liste ***
;
; FUNCTION SINUS (WINKEL : WORD) (RADIUS : WORD) (W1 : WORD) : WORD;
; PROCEDURE GRAFIKZEICHNEKREIS_ON_RAMPAGE (RADIUS : WORD) (X1 : WORD) (Y1 : WORD) (WINKEL : WORD);
 
; *** Konstanten-ARRAYs ***
;
 
SINTAB:
.dw    0x0000
.dw    0x0478
.dw    0x08EF
.dw    0x0D66
.dw    0x11DB
.dw    0x1650
.dw    0x1AC2
.dw    0x1F33
.dw    0x23A1
.dw    0x280C
.dw    0x2C74
.dw    0x30D9
.dw    0x3539
.dw    0x3996
.dw    0x3DEE
.dw    0x4242
.dw    0x4690
.dw    0x4AD9
.dw    0x4F1B
.dw    0x5358
.dw    0x578E
.dw    0x5BBE
.dw    0x5FE6
.dw    0x6407
.dw    0x681F
.dw    0x6C30
.dw    0x7039
.dw    0x7438
.dw    0x782F
.dw    0x7C1C
.dw    0x8000
.dw    0x83D9
.dw    0x87A8
.dw    0x8B6D
.dw    0x8F27
.dw    0x92D5
.dw    0x9679
.dw    0x9A10
.dw    0x9D9B
.dw    0xA11B
.dw    0xA48D
.dw    0xA7F3
.dw    0xAB4B
.dw    0xAE97
.dw    0xB1D4
.dw    0xB504
.dw    0xB826
.dw    0xBB39
.dw    0xBE3E
.dw    0xC134
.dw    0xC41B
.dw    0xC6F2
.dw    0xC9BA
.dw    0xCC73
.dw    0xCF1B
.dw    0xD1B3
.dw    0xD43B
.dw    0xD6B2
.dw    0xD919
.dw    0xDB6E
.dw    0xDDB3
.dw    0xDFE6
.dw    0xE208
.dw    0xE418
.dw    0xE616
.dw    0xE803
.dw    0xE9DD
.dw    0xEBA5
.dw    0xED5B
.dw    0xEEFE
.dw    0xF08F
.dw    0xF20D
.dw    0xF377
.dw    0xF4CF
.dw    0xF614
.dw    0xF746
.dw    0xF864
.dw    0xF96F
.dw    0xFA67
.dw    0xFB4B
.dw    0xFC1B
.dw    0xFCD8
.dw    0xFD81
.dw    0xFE17
.dw    0xFE98
.dw    0xFF06
.dw    0xFF5F
.dw    0xFFA5
.dw    0xFFD7
.dw    0xFFF5
.dw    0xFFFF
 
