PROGRAM test_array;

DEVICE = mega644P;


CONST

// Sinus-Tabelle
{$I SinTab.INC}



VAR
  x_max, x_kreis : Byte;
  w2, Grad : Word;
  dw1, dw2, dw3 : DWord;
  Sin_dw1, Sin_dw2 : DWord;
  X_PIX_POS, Y_PIX_POS : Word;



function Sinus(Winkel, Radius : Word) : Word;
var
  w1 : Word;
begin

  w1:=SinTab[Winkel];
  Sin_dw1:=WordToDWord(w1);
  Sin_dw2:=WordToDWord(Radius);
  Sin_dw1:=Sin_dw1*Sin_dw2;
  Sin_dw1:=Sin_dw1 DIV $FFFF;
  w1:=DWLow(Sin_dw1);

  Result:=w1;
end Sinus;









procedure GrafikZeichneKreis_on_Rampage(Radius : Word);
var
  x1 : Word;
  y1 : Word;
  Winkel : Word;
begin

  // Kreissegment 0..89 Grad
  for Winkel:=0 to 89 do
    // Delta Radius fuer x1
    x1:=Sinus(Winkel,Radius);

    // Delta Radius fuer y1
    y1:=90-Winkel;
    y1:=Sinus(y1,Radius);

    // x1 fuer Kreis-Punkt
    x1:=X_PIX_POS+x1;

    // y1 fuer Kreis-Punkt
    y1:=Y_PIX_POS-y1;

  //  SET_POINT_POS(x1,y1);
  endfor;

  // Kreissegment 90..179 Grad
  for Winkel:=0 to 89 do
    // Delta Radius fuer x1
    x1:=90-Winkel;
    x1:=Sinus(x1,Radius);

    // Delta Radius fuer y1
    y1:=Sinus(Winkel,Radius);

    // x1 fuer Kreis-Punkt
    x1:=X_PIX_POS+x1;

    // y1 fuer Kreis-Punkt
    y1:=Y_PIX_POS+y1;

  //  SET_POINT_POS(x1,y1);
  endfor;

  // Kreissegment 180..269 Grad
  for Winkel:=0 to 89 do
    // Delta Radius fuer x1
    x1:=Sinus(Winkel,Radius);

    // Delta Radius fuer y1
    y1:=90-Winkel;
    y1:=Sinus(y1,Radius);

    // x1 fuer Kreis-Punkt
    x1:=X_PIX_POS-x1;

    // y1 fuer Kreis-Punkt
    y1:=Y_PIX_POS+y1;

 //   SET_POINT_POS(x1,y1);

  endfor;

  // Kreissegment 270..359 Grad
  for Winkel:=0 to 89 do
    // Delta Radius fuer x1
    x1:=90-Winkel;
    x1:=Sinus(x1,Radius);

    // Delta Radius fuer y1
    y1:=Sinus(Winkel,Radius);

    // x1 fuer Kreis-Punkt
    x1:=X_PIX_POS-x1;

    // y1 fuer Kreis-Punkt
    y1:=Y_PIX_POS-y1;

 //   SET_POINT_POS(x1,y1);
  endfor;

end GrafikZeichneKreis_on_Rampage;





BEGIN

  w2:=Sinus(45,90);


  x_max:=100;
  Grad:=45;
 
  w2:=SinTab[Grad];
  dw1:=WordToDWord(w2);
  dw2:=ByteToDWord(x_max);
  dw3:=dw1*dw2;
  dw3:=dw3 DIV $FFFF;
  x_kreis:=DWordToByte(0,dw3);

END test_array.
